/* $Id: mem.java,v 1.47 2013/02/22 23:47:43 mit Exp $ */
/* mem.java v1.6.4 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.text.DecimalFormat;

public class mem extends Applet
    implements ItemListener, ActionListener, AdjustmentListener,
    MouseListener, MouseMotionListener
{
    final int Oct = 12;
    final int KB = 88;
    final int KC = KB+Oct*3;
    final int Cent = 1200;
    final int MEM_ = 0; // Grap
    final int FFT_ = 1; // "
    final int WAVE = 2; // "
    final int VIEW = 0; // "
    final int G_ = 1;   // burg data
    final int C_ = 2;   // "
    final int FPE = 3;  // "
    final int AIC = 4;  // "
    final double AA = 440.0;
    final double MC = Cent/Math.log(2);
    final String[] keynm = 
    {"A..","B..","H..","C..","Cis","D..","Es.","E..","F..","Fis","G..","Gis"};
    final String[] Spnm = {"9", "10", "11", "12", "13", "14"}; 
    final String[] Burg = {"Data", "G", "C", "FPE", "AIC"};
    final String[] West = {"MEM", "FFT", "WAVE"};

    Color darkGreen = new Color(80, 228, 80);    
    Color darkBlue = new Color(80, 80, 228);
    boolean Vsw;                 // graph./text
    boolean Msw;                 // mouse click
    boolean MMsw;                // mem on,off
    boolean FFsw;                // fft on,off
    int W;
    int H;
    int H2;
    int BH;
    int WH;
    int FNT;
    int AF;                      // all_file_num.
    int Splngf;                  // data sampling frq.
    int Nyq;                     // Splngf/2
    int Cnt;                     // wave data count
    int NB = 11;                 // n (9:512 10:1024 11:2048 12:4096)
    int NN;                      // 2^n
    int Wide;                    // 
    int Fwide;                   // FFT(MEM)
    int SPnum;                   // memɽڥȥ
    int Mmax;                    // ǥ뼡
    int Tlen;                    // temp length
    int Ds;                      // 
    int Band;                    // ϰ
    int HS;                      // ʬ
    int mX, mY;                  // mouse x/y
    int Level;                   // limiter
    int Flevel;                  // fft "
    int Mlevel;                  // mem "
    int Wstart;                  // wave view
    int Wend;                    // "
    int View;                    // data
    int Grap;                    // grap.
    double SS;                   // NN/Splngf:FFT
    double WW;                   // W/Wide
    double FW;                   // W/(SS*Wide):FFT
    double DB;                   // W/Band
    double DD;                   // W/burg data
    double Wby = 1.0;            // wave gain
    double Vby;                  // mem gain
    double Yby;                  // fft gain
    double Ymax;                 // fft max

    int[] dat;                  // wave data
    double[] yy;                // " fft
    double[] re;                // for fft
    double[] im;                // "
    double[] Han;               // hanning
    double[] Temp;              // data
    String[] filenm;
    String Error;
    String Dirnm;

    DecimalFormat df1;
    DecimalFormat df2;
    Graphics gi;
    Image ig;
    Font Fnt;
    FontMetrics fm;
    FFT fftN;
    MemBurg MB;

    private Choice chF;          // wave file
    private Choice chS;          // ץ󥰼
    private Choice chData;       // grap. & burg data
    private TextField tfA;       // error etc.
    private Button btP, btM;     // +/-
    private Button btW, btN;     // >/<
    private Button btT;          // graph.|text
    private Button[] btWest;     // mem/fft/wave
    private Scrollbar scrB;      // peak limit & wave view
    private Canvas can;
    private TextArea taA;
    private Panel deck;
    private CardLayout Card;
    private Panel PN, PE, PW, PS;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
	Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.00##");
	df2 = new DecimalFormat("#0.0#");

	buildLayout();
    }
    public void buildLayout() {
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());

	deck = new Panel();
        Card = new CardLayout();
        deck.setLayout(Card);
	//--- north

	PN = new Panel();
	PN.setLayout(new FlowLayout());
	add(PN, "North");

	tfA = new TextField(22);
        tfA.setForeground(Color.blue);
        tfA.setEditable(false);
        PN.add(tfA);

	String fn = getParameter("all_f");
        AF = (fn == null) ? 0 : Integer.parseInt(fn);
	if (AF == 0)
            Error = "No wave file.";
        filenm = new String[AF];   // max files
	Dirnm = getParameter("dirnm");
        Dirnm = (Dirnm == null) ? "" : Dirnm;
	chF = new Choice();
        for (int i = 0; i < AF; i++) {
            filenm[i] = getParameter("wave"+i);
	    chF.addItem(filenm[i]);
	}
        PN.add(chF);
        chF.addItemListener(this);

	chS = new Choice();            // NN
        for (int i = 0; i < Spnm.length; i++)
            chS.addItem(Spnm[i]);
        PN.add(chS);
	chS.select(""+NB);
        chS.addItemListener(this);

	chData = new Choice();
	for (int i = 0; i < Burg.length; i++)
	    chData.addItem(Burg[i]);
	PN.add(chData);
	chData.addItemListener(this);
	//-----------east

	PE = new Panel();
        PE.setLayout(new GridLayout(5,1,0,0));
	add(PE, "East");

        btP = new Button("+");
        btP.addActionListener(this);
        PE.add(btP);

	btM = new Button("-");
        btM.addActionListener(this);
        PE.add(btM);

	PE.add(new Label(""));

	btN = new Button(">");
        btN.addActionListener(this);
        PE.add(btN);

	btW = new Button("<");
        btW.addActionListener(this);
        PE.add(btW);
	//---------west

	PW = new Panel();
        PW.setLayout(new GridLayout(5,1,0,0));
	add(PW, "West");

	btWest = new Button[West.length];
	for (int i = 0; i < West.length; i++) {
	    btWest[i] = new Button(West[i]);
            btWest[i].addActionListener(this);
            PW.add(btWest[i]);
        }

	PW.add(new Label(""));

	btT = new Button("Text");
        btT.addActionListener(this);
        PW.add(btT);
	//-----------south

	PS = new Panel();
        PS.setLayout(new GridLayout(1,1,0,0));
        add(PS, "South");

	scrB = new Scrollbar(Scrollbar.HORIZONTAL, 1, 1, 1, 10);
        PS.add(scrB);
        scrB.addAdjustmentListener(this);
	//-------------------------center

	can = new MyCanvas();

	Panel g = new Panel();
        g.add(can);
        deck.add(g, "graph");

        taA = new TextArea("", 15, 45, TextArea.SCROLLBARS_BOTH);
        taA.setEditable(false);

        ScrollPane t = new ScrollPane();
        t.add(taA);
        deck.add(t, "text");

        add(deck, "Center");

	can.addMouseListener(this);
        can.addMouseMotionListener(this);
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;

	can.setSize(W, H);
	ig = createImage(W, H);
        gi = ig.getGraphics();
	gi.setFont(Fnt);

	H2 = H/2;
	HS = FNT*3; // shift
	BH = H-HS;  // base⤵
	WH = BH/2;  // wave
	MB = new MemBurg();
	View = VIEW;
	Grap = MEM_;
	set_db();

	if (isFile())
	    read_file(filenm[0]);
	enable_set();
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
	Dimension ds = PS.getSize();
        Dimension de = PE.getSize();
	Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-5;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void read_file(String fn) {
	if (!isFile()) 
	    return;

	read_data(Dirnm+fn);
	averge();
	Nyq = Splngf/2;
	Wide = Nyq;
	SPnum = Nyq;
	Wend = Band = Cnt;
	set_nn();
    }
    public boolean isFile() {
	return (AF > 0);
    }
    public void enable_set() {
	btP.setEnabled(!Vsw);
	btM.setEnabled(!Vsw);
	btW.setEnabled(!Vsw);
	btN.setEnabled(!Vsw);
	chS.setEnabled(!Vsw);

	boolean ms = (Grap == MEM_);
	chData.setEnabled(ms);
    }
    public void set_nn() {
	NN = (int)Math.pow(2, NB);
	if (Cnt > 0) {
	    while (NN > Cnt) {
		NB--;
	    }
	    NN = (int)Math.pow(2, NB);
	    chS.select(""+NB);
	}
	yy = new double[NN/2];
	SS = NN/(double)Splngf;
	Fwide = NN/2;                    //
	Mmax = (int)(2.0*Math.sqrt(NN)); //

	fftN = new FFT(NN);
	MB.setNN(NN, Splngf, Mmax);
	initHanning();

	if (Ds+NN > Cnt)
	    Ds = Cnt-NN;
	else if (NN > Cnt)
	    Ds = 0;

	set_wave_scr();
	FFsw = false;
	MMsw = false;
	calc_();
    }

    public void mouseMoved(MouseEvent m) {
	if (!Msw && !Vsw) {
	    mX = m.getX();
	    can.repaint();
	}
    }
    public void mousePressed(MouseEvent m) { 
	if (!Vsw) {
	    Msw = !Msw;
	    mX = m.getX();
	    can.repaint();
	}
    }
    public void mouseClicked(MouseEvent m) { }
    public void mouseDragged(MouseEvent m) { }
    public void mouseReleased(MouseEvent m) { }
    public void mouseEntered(MouseEvent m) { }
    public void mouseExited (MouseEvent m) { }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrB) {   // limit (text)
	    if (Grap == WAVE) {
		FFsw = false;
		MMsw = false;
	    }
	    disp_sw();
	}
    }

    public void actionPerformed(ActionEvent e) {
	if (e.getSource() == btM)       // -
            set_val(false);
        else if (e.getSource() == btP)  // +
            set_val(true);

	else if (e.getSource() == btW)  // max.f /2
            set_wide(false);
        else if (e.getSource() == btN)  // max.f x2
            set_wide(true);

	else if (e.getSource() == btT){  // graph./text
	    Vsw = !Vsw;
	    btT.setLabel(Vsw ? "Text" : "Grap.");
	    Card.next(deck);
	}

	else if (e.getSource() == btWest[MEM_])
	    to_mem();
	else if (e.getSource() == btWest[FFT_])
	    to_fft();
	else if (e.getSource() == btWest[WAVE])
	    to_wave();

	enable_set();
	disp_sw();
    }
    public void save_scrollbar() {
	switch(Grap) {
	case FFT_:
	    Flevel = scrB.getValue();
	    break;
	case MEM_:
	    Mlevel = scrB.getValue();
	    break;
	case WAVE:
	    Ds = scrB.getValue();
	default:
	}
    }
    public void to_mem() {
	save_scrollbar();
	Grap = MEM_;

	scrB.setValues(Mlevel, 1, 0, (int)MB.getXmax());
	int min = (int)(MB.getXmax()/10);
	scrB.setBlockIncrement(min < 1 ? 1 : min);
	min = (int)(MB.getXmax()/100);
	scrB.setUnitIncrement(min < 1 ? 1 : min);
	calc_();
    }
    public void to_fft() {
	save_scrollbar();
	Grap = FFT_;

	scrB.setValues(Flevel, 1, 0, (int)Ymax);
	int min = (int)(Ymax/10);
	scrB.setBlockIncrement(min < 1 ? 1 : min);
	min = (int)(Ymax/100);
	scrB.setUnitIncrement(min < 1 ? 1 : min);
	calc_();
    }
    public void to_wave() {
	save_scrollbar();
	Grap = WAVE;

	set_wave_scr();
    }
    public void set_wave_scr() {
	scrB.setValues(Ds, NN, 0, Cnt);
	scrB.setBlockIncrement(NN);
	scrB.setUnitIncrement(NN/2);
    }
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == chF)             // choice file
	    read_file(chF.getSelectedItem());

	if (e.getSource() == chS) {           // 9:10:11~  
	    NB = Integer.parseInt(chS.getSelectedItem());	    
	    if (MB != null)
		set_nn();
	}

	if (e.getSource() == chData)
	    View = chData.getSelectedIndex();

	disp_sw();
    }
    public void calc_() {
	if (!isFile())
	    return;

	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 
	tfA.setText(Ds+"/"+Cnt);

	switch(Grap) {
	case FFT_:
	    if (!FFsw) {
		fft();
		Flevel = (int)(Ymax/100);
		scrB.setValues(0, 1, Flevel, (int)Ymax);
	    }
	    break;
	case MEM_:
	    if (!MMsw){
		MB.calcMem(Ds, dat);
		double max = MB.getXmax();
		Vby = (BH-2)/max;
		MMsw = true;
		Mlevel = (int)(max/100);
		scrB.setValues(0, 1, Mlevel, (int)max);
	    }
	    break;
	case WAVE:
	    break;
	default:
	}

	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }
    public void disp_sw() {
	if (MB == null)
	    return;

	switch (Grap) {
	case FFT_:
	case MEM_:
	    Level = scrB.getValue();
	    break;
	case WAVE:
	    Ds = scrB.getValue();
	    break;
	default:
	}

	if (Vsw)
            re_write();     // text
        else
            can.repaint();  // graph.
    }

    public double ftoc(int keyn, double f) {
	return MC * Math.log(f/getFreq(keyn));
    }
    public int ftok(double sf) {
        int key = (int)Math.rint(Oct*Math.log(sf/getFreq(0))/Math.log(2));
        if (key < 0)
            key = 0;
        else if (key >= KC)
            key = KC-1;
        return key;
    }
    public double getFreq(int key) {
        return AA*Math.pow(2, (key-48)/(double)Oct); // 0~87
    }
    public void set_wide(boolean sw) {
	switch (Grap) {
	case FFT_:
	case MEM_:
	    Wide = sw ? Wide*2 : Wide/2;
	    Fwide = sw ? Fwide*2 : Fwide/2;
	    if (Wide > Nyq) {
		Wide = Nyq;
		Fwide = NN/2;
	    }
	    int min = 1; // hz
	    if (Wide < min) {
		Wide = min;
		Fwide *= 2;
	    } else if (Fwide < min) {
		Fwide = min;
		Wide *= 2;
	    }
	    break;
	case WAVE:
	    Band = sw ? Band*2: Band/2;
	    if (Band >= Cnt)
		Band = Cnt;
	    else if (Band < NN)
		Band = NN;

	    FFsw = false;
	    MMsw = false;
	    break;
	default:
	}
    }
    public void set_val(boolean sw) {
	double l2 = Math.sqrt(2);
	switch (Grap) {
	case FFT_:
	    Yby = sw ? Yby*l2 : Yby/l2;
	    break;
	case MEM_:
	    Vby = sw ? Vby*l2 : Vby/l2;
	    break;
	case WAVE:
	    Wby = sw ? Wby*l2 : Wby/l2;
	    break;
	default:
	}
    }
    public void set_freq() {
	WW = W/(double)Wide;
	FW = W/(SS*Wide);
    }
    public void set_db() {
	DB = (double)W/Band; 
    }
    public void re_write() {
	if (!isFile())
	    return;

	switch(Grap) {
	case FFT_:
	    ifpk(yy);
	    break;
	case MEM_:
	    if (View == VIEW)
		mem_peak(MB.getData());
	    else
		write_data();
	    break;
	case WAVE:
	    write_wave_data();
	    break;
	default:
	}
    }
    public void write_data() {
	StringBuffer str = new StringBuffer();
	Tlen = burg_data();

	for (int i = 1; i <= Tlen; i++)
	    str.append(i+" "+Temp[i]+"\n");

	taA.setText(str.toString());
    }
    public void ifpk(double[] x) {
	StringBuffer str = new StringBuffer(1024);
	str.append(make_peak_head());

	double delf = 1.0/SS;
	int nptm1 = Fwide;
	int stt = 0;
	int npk = 0;
	double a, b;
	double beta, pek, frq;
	for (int i = stt+2; i < nptm1-1; i++) {
            if (x[i] > Level) {
                if ((Math.abs(x[i]) >= Math.abs(x[i-1])) &&
                    (Math.abs(x[i]) >= Math.abs(x[i+1]))) {
		    /*
                    beta = 3.0/(1+x[i]/x[i+1])-1;
                    pek = ((Math.PI*(1+beta)*beta*(1-beta))/
                          Math.sin(Math.PI*beta))*x[i];
		    frq = (i+beta)*delf;
		    
		    a = (x[i+1]+x[i-1])/2.0-x[i];
		    b = (x[i+1]-x[i-1])/2.0;
		    pek = x[i]-b*b/(4.0*a);
		    frq = (-b/(2.0*a)+i)*delf;
		    */
		    pek = x[i];
		    frq = i*delf;
		    
		    str.append(d_num(npk++, frq, pek, i));
                    i += 2;
                }
            }
	}

   	taA.setText(str.toString());
    }
    public void mem_peak(double[] x) {
	StringBuffer str = new StringBuffer(1024);
	str.append(make_peak_head());

	double delf = 1.0/SS;
	int nptm1 = Fwide;
	int stt = 1; // 1~
	int npk = 0;
	double frq;
	for (int i = stt+2; i < nptm1-1; i++) {
	    if (i >= SPnum)
		break;
            if (x[i] > Level) {
                if ((Math.abs(x[i]) >= Math.abs(x[i-1])) &&
                    (Math.abs(x[i]) >= Math.abs(x[i+1]))) {
		    frq = delf*(i-1); // i-1 ȿ碌
		    str.append(d_num(npk++, frq, x[i], i));
                    i += 2;
		}
	    }
	}

	taA.setText(str.toString());
    }
    public String make_peak_head() {
	StringBuffer str = new StringBuffer();

	str.append("Sampling f. "+Splngf);
	str.append(": Data num. "+Ds);
	str.append("/"+Cnt); 
	str.append(": Sampl num. "+NN);
	str.append("\n#: [Hz] Key#: [cent]: peak>");
	str.append(dform(Level)+": # \n");
	str.append("------------------------------------\n");

	return str.toString();
    }
    public String d_num(int n, double f, double p, int j) {
	StringBuffer str = new StringBuffer(1024);
	String sp = ": ";

	int k = ftok(f);
	str.append((n+1)+sp+dform(f));
	str.append(" "+(k+1)+keynm[k%Oct]);
	str.append(sp+dform(ftoc(k, f)));
	str.append(sp+dform(p));
	str.append(sp+j+"\n");

	return str.toString();
    }
    public void write_wave_data() {
	StringBuffer str = new StringBuffer();
	
	str.append("Start: "+Wstart+" End: "+Wend);
	str.append(" ("+dform(100.0*(Wend-Wstart)/(double)Cnt)+"[%])");
	taA.setText(str.toString());
    }
    public String dform(double nm) {
	return df1.format((float)nm);
    }
    public String dform2(double nm) {
	return df2.format((float)nm);
    }
    public void initHanning() {
        Han = new double[NN];
        double rn = 1.0/NN;
	double PI2 = Math.PI*2;

        for (int i = 0; i < NN; i++)
            Han[i] = 0.5-0.5*Math.cos(PI2*i*rn);
    }
    public void hanning() {
        for (int i = 0; i < NN; i++)
	    im[i] = re[i] = (i < Cnt) ? dat[i+Ds]*Han[i] : 0.0;
    }
    public void fft() {
	re = new double[NN];
        im = new double[NN];
	hanning();

	Ymax = 0.0;
        fftN.fft(re, im);
        for (int i = 0; i < NN/2; i++) {
            yy[i] = Math.sqrt(re[i]*re[i]+im[i]*im[i]);
	    if (yy[i] > Ymax)
		Ymax = yy[i];
	}
	Yby = (BH-2)/Ymax;
	FFsw = true;
    }
    //-----

    class MyCanvas extends Canvas {
	public void update(Graphics g) {
	    can.paint(g);
	}
	public void paint(Graphics g) {
	    paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() {
	gi.setColor(Color.black);
	gi.fillRect(0, 0, W, H);

	set_freq();
	set_db();

	switch(Grap) {
	case FFT_:
	    disp_fft(gi);
	    break;
	case MEM_:
	    if (View == VIEW)
		disp_mem(gi);
	    else
		disp_data(gi);
	    break;
	case WAVE:
	    disp_wave(gi);
	default:
	}

	disp_mouse(gi);
    }
    //
    public void disp_data(Graphics g) {
	if (MB == null)
	    return;

	Tlen = burg_data();
	DD = W/(double)Tlen;
	double[] dd = disp_minmax(g); // dh, dc

	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);

	int x0, y0, x1 = 0, y1 = 0;
	g.setColor(Color.green);
	for (int i = 0; i <= Tlen; i++) {
	    x0 = (int)(DD*i);
	    if (i == 0) {
		x1 = x0;
		continue;
	    }
	    y0 = (int)(H2-(Temp[i]-dd[1])*dd[0]); // dc, dh
	    if (i == 1) {
		y1 = y0;
	    }
	    g.drawLine(x0, y0, x1, y0);
	    g.drawLine(x1, y0, x1, y1);
	    x1 = x0;
	    y1 = y0;
	}
    }
    public int burg_data() {
	switch(View) {
	case G_:
	    Temp = MB.getG();
	    break;
	case C_:
	    Temp = MB.getC();
	    break;
	case FPE:
	    Temp = MB.getFPE();
	    break;
	case AIC:
	    Temp = MB.getAIC();
	    break;
	default:
	    Temp = null;
	}
	if (Temp == null) {
	    System.out.println("No data.");
	    return -1;
	}

	return Temp.length-1;
    }
    public double[] disp_minmax(Graphics g) {
	double max = Double.MIN_VALUE, min = Double.MAX_VALUE;
	for (int i = 1; i <= Tlen; i++) {
	    if (max < Temp[i])
		max = Temp[i];
	    if (min > Temp[i])
		min = Temp[i];
	}
	double[] tmp = new double[2];
	tmp[0] = H2/(max-min); // dh
	tmp[1] = (max+min)/2;  // dc

	g.setColor(Color.red);
	g.drawString("max:"+(float)max+"  Mmax:"+Mmax, 10, FNT);
	g.drawString("min:"+(float)min, 10, H-FNT);

	return tmp;
    }
    //
    public void disp_wave(Graphics g) {
	double ga = WH/(double)Short.MAX_VALUE;
	int val, max = Integer.MIN_VALUE, min = Integer.MAX_VALUE;

	g.setColor(Color.lightGray);
	g.drawLine(0, WH, W, WH);
	g.drawLine(0, BH, W, BH);

	set_wave_band();
	int i0 = 0;
	double x0, y0;
	for (int i = Wstart; i < Wend; i++) {
	    g.setColor((i >= Ds && i < Ds+NN) ?
		       Color.yellow : Color.green);
	    val = dat[i];
	    max = Math.max(max, val);
            min = Math.min(min, val);
	    x0 = DB*i0;
	    y0 = WH-ga*val*Wby;
	    g.drawLine((int)x0, (int)y0, (int)x0, (int)y0);
	    i0++;
	}

	disp_time(g);
	disp_wave_value(g, min, max);
    }
    public void set_wave_band() {
	Wend = Wstart+Band;

	if (Wend > Cnt) {
	    Wend = Cnt;
	    Wstart = Wend-Band;
	}
	if (Ds+NN > Wend) {
	    Wstart += (Ds+NN)-Wend;
	    Wend = Wstart+Band;
	} else if (Ds < Wstart) {
	    Wstart = Ds;
	    Wend = Wstart+Band;
	}  
    }
    public void disp_time(Graphics g) {
        double tim, allsec = Band/(double)Splngf;

        if (allsec < 0.1)
            tim = 0.01;
        else if (allsec < 0.3)
            tim = 0.05;
        else if (allsec < 1)
            tim = 0.1;
        else if (allsec < 3)
            tim = 0.5;
        else if (allsec < 10)
            tim = 1;
        else if (allsec < 30)
            tim = 5;
        else if (allsec < 60)
            tim = 10;
        else
            tim = 60;

        String s = "[sec] ";
        g.setColor(Color.yellow);
        g.drawString(s, W-fm.stringWidth(s), H-2);

        double asec = tim/(allsec/W);
        int maxsec = (int)(allsec/tim);
        if (maxsec > 0) {
            int ss = H-FNT;  // ʸh
            int x, l = 5;
            for (int i = 0; i <= maxsec; i++) {
                x = (int)(asec*i);

                g.setColor(Color.gray);
                g.drawLine(x, BH, x, BH+l);

                g.setColor(Color.yellow);
                g.drawString(dform2(i*tim), x, ss);
            }
        }
    }
    public void disp_wave_value(Graphics g, int min, int max) {
	double mi = (double)min/Short.MAX_VALUE;
	double mx = (double)max/Short.MAX_VALUE;

        g.setColor(Color.lightGray);
        g.drawString(dform2(100*mi)+"[%]", 1, BH-2);
        g.drawString(dform2(100*mx)+"[%]", 1, FNT);  /* ȾȤ100% */
    }
    public void disp_limit(Graphics g, double by) {
	int lh = (int)(BH-Level*by);

	g.setColor(darkBlue);
	g.drawLine(0, lh, W, lh);
    }
    public void disp_mouse(Graphics g) {
	StringBuffer str = new StringBuffer();

	g.setColor(Color.white);
	g.drawLine(mX, 0, mX, H-1);

	if (Error.equals("")) {
	    double mf = mX/WW;
	    double val = 0;
	    int nn;

	    if (View == VIEW) {
		switch (Grap) {
		case FFT_:
		    nn = (int)(mX/FW);
		    val = yy[nn];
		    str.append(dform(mf)+"[Hz]:");
		    break;
		case MEM_:
		    nn = (int)(mX/FW)+1;
		    if (nn < SPnum)
			val = MB.getData(nn);
		    str.append(dform(mf)+"[Hz]:");
		    break;
		case WAVE:
		    nn = (int)(mX/DB);
		    val = dat[nn];
		    str.append(nn+":");
		    break;
		default:
		}
		str.append(dform(val));
	    } else {
		nn = (int)(mX/DD)+1;
		val = Temp[nn];
		str.append(nn+":"+dform(val));
	    }
	    tfA.setText(str.toString());
	} else 
	    tfA.setText(Error);
    }
    public void disp_meas(Graphics g) {
	int dx, mej = 0;

	for (int i = 0; i <= Wide; i++) {
	    if (i%10000 == 0) {
		mej = 13;
		if (Wide >= 10000)
		    disp_k(g, i);
	    } else if (i%1000 == 0) {
		mej = 10;
		if (Wide < 12000)
		    disp_k(g, i);
	    } else if (i%500 == 0) {
		mej = 7;
	    } else if (i%100 == 0) {
		mej = 4;
	    } else if (i%10 == 0) {
		if (Wide > 2000)
		    continue;
		mej = 2;
	    } else
		continue;

	    dx = (int)(i*WW);
	    g.setColor(Color.gray);
	    g.drawLine(dx, BH, dx, BH+mej);
	}

	g.setColor(Color.gray);
	g.drawLine(0, BH, W, BH);
    }
    public void disp_k(Graphics g, int j) {
	g.setColor(Color.orange);
	g.drawString(j/1000+"k", (int)(j*WW), H-FNT);
    }
    //
    public void disp_fft(Graphics g) {
	disp_limit(g, Yby);
	disp_meas(g);

	int ww = (FW < 1) ? 1 : (int)FW;
	double v1;

	g.setColor(darkGreen);
	for (int i = 0; i < Fwide; i++) {
	    v1 = yy[i]*Yby;
	    g.drawRect((int)(FW*i), (int)(BH-v1), ww, (int)v1);
	}
    }
    //
    public void disp_mem(Graphics g) {
	disp_limit(g, Vby);
	disp_meas(g);

	double x0, y0, x1 = 0, y1 = 0;

	g.setColor(darkGreen);
	for (int i = 0; i < Fwide; i++) {
	    if (i >= SPnum)
		break;
	    x0 = FW*i;
	    y0 = BH-MB.getData(i+1)*Vby; // +1
	    if (i == 0) {
		x1 = x0;
		y1 = y0;
	    }
	    g.drawLine((int)x0, (int)y0, (int)x1, (int)y1);
	    x1 = x0;
	    y1 = y0;
	}
    }
    //
    public void averge() {
	double sum = 0;
	int i;

	for (i = 0; i < Cnt; i++)
	    sum += dat[i];
	double ave = sum/Cnt;
	for (i = 0; i < Cnt; i++)
	    dat[i] -= ave;
    }
    public void read_data(String fname) {
        try {
            URL url = new URL(getDocumentBase(), fname);
            ReadWave rw = new ReadWave(url);

            dat = rw.getData();
            Splngf = rw.getSamplf();
            Cnt = rw.getCount();
            String lavel = rw.getLavel();
            Error = rw.getError();

            tfA.setText(lavel+Splngf);
        } catch(Exception e) {
            Error = "File read error.";
        }
    }
}
